## ros-galactic-geometric-shapes 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(geometric_shapes)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

# Set compile options
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(PROJECT_COMPILE_OPTIONS
    -Wall
    -Wextra
    -Wwrite-strings
    -Wunreachable-code
    -Wpointer-arith
    -Wredundant-decls
    -Wno-unused-parameter
  )
endif()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: Choosing 'Release' for maximum performance")
  set(CMAKE_BUILD_TYPE Release)
endif()

# TODO(henningkayser): Remove policy fix when assimp 5.1 is available
# Suppress policy warning in assimp (https://github.com/assimp/assimp/pull/2722)
set(CMAKE_POLICY_DEFAULT_CMP0012 NEW)
find_package(ASSIMP QUIET)
if(NOT ASSIMP_FOUND)
  find_package(PkgConfig REQUIRED)
  # assimp is required, so REQUIRE the second attempt
  pkg_check_modules(ASSIMP_PC REQUIRED assimp)
  set(ASSIMP_INCLUDE_DIRS ${ASSIMP_PC_INCLUDE_DIRS})
endif()

# find *absolute* paths to ASSIMP_LIBRARIES
# Both, pkg-config and assimp's cmake-config don't provide an absolute library path.
# For, pkg-config the path is in ASSIMP_PC_LIBRARY_DIRS, for cmake in ASSIMP_LIBRARY_DIRS.
find_library(ASSIMP_ABS_LIBRARIES NAMES ${ASSIMP_LIBRARIES} assimp HINTS ${ASSIMP_LIBRARY_DIRS} ${ASSIMP_PC_LIBRARY_DIRS})
set(ASSIMP_LIBRARIES "${ASSIMP_ABS_LIBRARIES}")

# These need to be in this order to find header files
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)

find_package(ament_cmake REQUIRED)
include(ConfigExtras)
find_package(console_bridge REQUIRED)
find_package(console_bridge_vendor REQUIRED)
find_package(eigen_stl_containers REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(OCTOMAP REQUIRED)
find_package(QHULL REQUIRED)
find_package(random_numbers REQUIRED)
find_package(rclcpp REQUIRED)
find_package(resource_retriever REQUIRED)
find_package(shape_msgs REQUIRED)
find_package(visualization_msgs REQUIRED)

set(THIS_PACKAGE_EXPORT_DEPENDS
  eigen3_cmake_module
  Eigen3
  Boost
  console_bridge
  console_bridge_vendor
  eigen_stl_containers
  geometry_msgs
  OCTOMAP
  random_numbers
  rclcpp
  resource_retriever
  shape_msgs
  visualization_msgs
)

# Set VERSION from package.xml
ament_package_xml()

include_directories(include)

add_library(${PROJECT_NAME} SHARED
  src/aabb.cpp
  src/bodies.cpp
  src/body_operations.cpp
  src/mesh_operations.cpp
  src/shape_extents.cpp
  src/shape_operations.cpp
  src/shape_to_marker.cpp
  src/shapes.cpp
)
set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${${PROJECT_NAME}_VERSION} WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
target_compile_options(${PROJECT_NAME} PRIVATE ${PROJECT_COMPILE_OPTIONS})
ament_target_dependencies(${PROJECT_NAME}
  ${THIS_PACKAGE_EXPORT_DEPENDS}
)
ament_target_dependencies(${PROJECT_NAME} SYSTEM
  # We don't export these dependencies because their cmake is broken
  ASSIMP
  QHULL
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  # Unit tests
  add_subdirectory(test)

  # ament_lint
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

install(
  TARGETS ${PROJECT_NAME}
  EXPORT export_${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)
install(DIRECTORY include/ DESTINATION include)

ament_export_targets(export_${PROJECT_NAME} HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_EXPORT_DEPENDS})

ament_package(CONFIG_EXTRAS "cmake/ConfigExtras.cmake")

=== test/CMakeLists.txt ===
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
if(WIN32)
    # Correct directory separator for Windows
    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR "${TEST_RESOURCES_DIR}")
endif()
configure_file(resources/config.h.in "${CMAKE_CURRENT_BINARY_DIR}/resources/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ament_add_gtest(test_basics test_basics.cpp)
ament_target_dependencies(test_basics Eigen3)

ament_add_gtest(test_point_inclusion test_point_inclusion.cpp)
target_link_libraries(test_point_inclusion ${PROJECT_NAME})

ament_add_gtest(test_bounding_sphere test_bounding_sphere.cpp)
target_link_libraries(test_bounding_sphere ${PROJECT_NAME})

ament_add_gtest(test_bounding_box test_bounding_box.cpp)
target_link_libraries(test_bounding_box ${PROJECT_NAME})

ament_add_gtest(test_bounding_cylinder test_bounding_cylinder.cpp)
target_link_libraries(test_bounding_cylinder ${PROJECT_NAME})

ament_add_gtest(test_create_mesh test_create_mesh.cpp)
target_link_libraries(test_create_mesh ${PROJECT_NAME})

ament_add_gtest(test_loaded_meshes test_loaded_meshes.cpp)
target_link_libraries(test_loaded_meshes ${PROJECT_NAME})

ament_add_gtest(test_shapes test_shapes.cpp)
target_link_libraries(test_shapes ${PROJECT_NAME})

ament_add_gtest(test_ray_intersection test_ray_intersection.cpp)
target_link_libraries(test_ray_intersection ${PROJECT_NAME})

ament_add_gtest(test_body_operations test_body_operations.cpp)
target_link_libraries(test_body_operations ${PROJECT_NAME})

=== debian/changelog ===
ros-galactic-geometric-shapes (2.1.2-1focal) focal; urgency=high

  * Fix cmake such that Boost::filesystem is exported properly (#206 <https://github.com/ros-planning/geometric_shapes/issues/206>)
    Co-authored-by: Jordan Lack <mailto:jlack@houstonmechatronics.com>
  * Contributors: Jafar Abdi

 -- Tyler Weaver <tyler@picknik.ai>  Wed, 22 Dec 2021 00:00:00 -0000

ros-galactic-geometric-shapes (2.1.1-1focal) focal; urgency=high

  * Changed retriever.h to retriever.hpp in mesh_operations.cpp in order to align with resource_retriever ros2 branch (#200 <https://github.com/ros-planning/geometric_shapes/issues/200>)
  * Add Copyright and LICENSE files
  * Fix building on Windows with MSVC (#189 <https://github.com/ros-planning/geometric_shapes/issues/189>)
  * Contributors: Akash, Diego Rojas, Mark Moll, Tyler Weaver, Vatan Aksoy Tezer

 -- Tyler Weaver <tyler@picknik.ai>  Mon, 27 Sep 2021 00:00:00 -0000

ros-galactic-geometric-shapes (2.1.0-1focal) focal; urgency=high

  * Add Galactic CI, cleanup rolling (#190 <https://github.com/ros-planning/geometric_shapes/issues/190>)
  * Sync ros2 branch with noetic-devel up to d147f03 <https://github.com/ros-planning/geometric_shapes/commit/d147f0371afbece0b8c93a2d2d55149a284d5192> (#190 <https://github.com/ros-planning/geometric_shapes/issues/190>)
  * Contributors: Jafar Abdi, Henning Kayser, Vatan Aksoy Tezer

 -- Tyler Weaver <tyler@picknik.ai>  Tue, 15 Jun 2021 00:00:00 -0000

ros-galactic-geometric-shapes (2.0.2-1focal) focal; urgency=high

  * Declare assimp add qhull as SYSTEM dependency to suppress compiler warnings (#186 <https://github.com/ros-planning/geometric_shapes/issues/186>)
  * Fix export depends (#182 <https://github.com/ros-planning/geometric_shapes/issues/182>)
  * Add rolling to CI test (#179 <https://github.com/ros-planning/geometric_shapes/issues/179>)
  * Contributors: Jafar Abdi, Tyler Weaver

 -- Tyler Weaver <tyler@picknik.ai>  Sat, 22 May 2021 00:00:00 -0000

ros-galactic-geometric-shapes (2.0.1-1focal) focal; urgency=high

  * Set target compile options in cmake for warnings
  * [fix] cmake install command (#164 <https://github.com/ros-planning/geometric_shapes/issues/164>)
  * Contributors: Tyler Weaver

 -- Tyler Weaver <tyler@picknik.ai>  Fri, 09 Apr 2021 00:00:00 -0000

ros-galactic-geometric-shapes (2.0.0-1focal) focal; urgency=high

  * [maint] Travis: Disable warnings as gcc warns about redundant declarations in qhull includes
  * [maint] Inherit package VERSION (for library soname) from package.xml
  * [maint] Trim boost dependencies #156 <https://github.com/ros-planning/geometric_shapes/issues/156>
    * libboost-math libraries unnecessary as only headers-only parts are used
    * move author tags below to comply with the xsd
  * [maint] Compile on ROS2 Foxy (#153 <https://github.com/ros-planning/geometric_shapes/issues/153>)
    * Suppress assimp CMP0012 policy warning
    * Use console_bridge_vendor dependency wrapper
    * Fix CMakeLists issues:remove ASSIMP export dependency
    
    fix linking of OCTOMAP, resource_retriever
  * [maint] Resolve octomap dependency with rosdep (#124 <https://github.com/ros-planning/geometric_shapes/issues/124>)
  * [maint] struct SolidPrimitiveDimCount -> function solidPrimitiveDimCount() (#121 <https://github.com/ros-planning/geometric_shapes/issues/121>)
  * [ros2-migration] Port to ROS 2 (#122 <https://github.com/ros-planning/geometric_shapes/issues/122>)
    * Migrate CMakeLists.txt, package.xml, messages
    * Enable Travis: Run on ROS 2, enable ament_lint_cmake
  * Contributors: Henning Kayser, Mikael Arguedas, Robert Haschke, Víctor Mayoral Vilches

 -- Tyler Weaver <tyler@picknik.ai>  Fri, 20 Nov 2020 00:00:00 -0000

ros-galactic-geometric-shapes (0.7.2-1focal) focal; urgency=high

  * [maint] Renamed SolidPrimitiveDimCount<shape>::value -> solidPrimitiveDimCount<shape>() (#121 <https://github.com/ros-planning/geometric_shapes/issues/121>)
  * [maint] cmake: Consistently use uppercase letters for QHULL dependency
  * [maint] cmake: Fix assimp warning
  * [maint] Update build badges for Noetic
  * Contributors: Robert Haschke

 -- Tyler Weaver <tyler@picknik.ai>  Fri, 25 Sep 2020 00:00:00 -0000

ros-galactic-geometric-shapes (0.7.1-1focal) focal; urgency=high

  * [maint] Declare external includes as SYSTEM includes
  * [maint] Migration to reentrant qhull (#149 <https://github.com/ros-planning/geometric_shapes/issues/149>)
  * [maint] Use soname version for library (#157 <https://github.com/ros-planning/geometric_shapes/issues/157>)
  * Contributors: Jochen Sprickerhof, Robert Haschke, Tyler Weaver

 -- Tyler Weaver <tyler@picknik.ai>  Mon, 31 Aug 2020 00:00:00 -0000

ros-galactic-geometric-shapes (0.7.0-1focal) focal; urgency=high

  * [feature] Added constructShapeFromBody() and constructMarkerFromBody() (#138 <https://github.com/ros-planning/geometric_shapes/issues/138>)
  * [maint]   API cleanup
    * Improve inlining
    * ConvexMesh::MeshData as pimpl
    * Reverted ABI compatibility fixups for Melodic: ed4cf1339cf3765ae9ffa6e6fd111a4e342c5fa2, d582479084a10cac53a7f17e29818b3d8be6161e
  * Contributors: Martin Pecka, Robert Haschke

 -- Tyler Weaver <tyler@picknik.ai>  Mon, 25 May 2020 00:00:00 -0000

ros-galactic-geometric-shapes (0.6.3-1focal) focal; urgency=high

  * [maint]   Provide checkIsometry() helper function (#144 <https://github.com/ros-planning/geometric_shapes/issues/144>)
  * [maint]   Remove dynamic casts (#143 <https://github.com/ros-planning/geometric_shapes/issues/143>)
  * [feature] Added createEmptyBodyFromShapeType() (#137 <https://github.com/ros-planning/geometric_shapes/issues/137>)
    This allows more efficient body construction when scale, padding or pose should also be set during the construction.
  * Contributors: Martin Pecka, Michael Görner

 -- Tyler Weaver <tyler@picknik.ai>  Mon, 25 May 2020 00:00:00 -0000

ros-galactic-geometric-shapes (0.6.2-1focal) focal; urgency=high



=== debian/control ===
Source: ros-galactic-geometric-shapes
Section: misc
Priority: optional
Maintainer: Tyler Weaver <tyler@picknik.ai>
Build-Depends: debhelper (>= 9.0.0), libassimp-dev, libboost-dev, libboost-filesystem-dev, libeigen3-dev, libqhull-dev, pkg-config, ros-galactic-ament-cmake, ros-galactic-ament-cmake-copyright, ros-galactic-ament-cmake-gtest, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-cmake, ros-galactic-console-bridge-vendor, ros-galactic-eigen-stl-containers, ros-galactic-eigen3-cmake-module, ros-galactic-geometry-msgs, ros-galactic-octomap, ros-galactic-random-numbers, ros-galactic-rclcpp, ros-galactic-resource-retriever, ros-galactic-rosidl-default-generators, ros-galactic-shape-msgs, ros-galactic-visualization-msgs, ros-galactic-ros-workspace
Homepage: http://ros.org/wiki/geometric_shapes
Standards-Version: 3.9.2

Package: ros-galactic-geometric-shapes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libassimp-dev, libboost-dev, libboost-filesystem1.71.0, libeigen3-dev, libqhull-dev, ros-galactic-console-bridge-vendor, ros-galactic-eigen-stl-containers, ros-galactic-eigen3-cmake-module, ros-galactic-geometry-msgs, ros-galactic-octomap, ros-galactic-random-numbers, ros-galactic-rclcpp, ros-galactic-resource-retriever, ros-galactic-rosidl-default-runtime, ros-galactic-shape-msgs, ros-galactic-visualization-msgs, ros-galactic-ros-workspace
Description: This package contains generic definitions of geometric shapes and bodies.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-geometric-shapes//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
